import sys
import time
import pymssql
import traceback

class dbwriter:
    def __init__(self,addr):
        self.db = False
        self.address = addr

    def Connect(self):
        try:
            print "Connecting to MSSQL Database..."
            bits = self.address.split(':')

            self.table = bits[5]
            self.lookup = bits[6]
            self.stamp = bits[7]
            self.value = bits[8]
            self.db = pymssql.connect(host=bits[0] + ":" + bits[1],user=bits[3],password=bits[4],database=bits[2],login_timeout=10)#MySQLdb.connect(bits[0],bits[3],bits[4],bits[2],port=int(bits[1]))
            print "Connection Successful!"
            return True
        except:
            traceback.print_exc()
            return False

    def Prepare(self,channels):
        self.lookups = False
        #print "Checking For Lookup Table..."
        #Check to see if a lookup table exists...
        try:
            cursor = self.db.cursor()

            #print "SELECT name," + self.lookup + " FROM " + self.table + "_lookup"

            cursor.execute("SELECT name," + self.lookup + " FROM " + self.table + "_lookup")
            results = cursor.fetchall()
            self.lutable = {}
            for r in results:
                self.lutable[r[0]] = r[1]

            #OK - we've loaded all of the existing lookups!

            #Are any missing?
            syncer = ""
            
            for v in channels:
                if v.field not in self.lutable:
                    if (syncer != ""):
                        syncer += ","
                    syncer += "(" + repr(v.field) + ")"

            if syncer != "":

                qry = "INSERT INTO " + self.table + "_lookup (name) VALUES " + syncer
                print qry
                cursor = self.db.cursor()
                cursor.execute(qry)
                self.db.commit()
                #print "Updating Lookup Table With New Options"

                cursor = self.db.cursor()
                cursor.execute("SELECT name," + self.lookup + " FROM " + self.table + "_lookup")
                results = cursor.fetchall()
                self.lutable = {}
                for r in results:
                    self.lutable[r[0]] = r[1]

            self.lookups = True
            print "Lookup Found!"

            #print str(self.lutable)
        except:
            traceback.print_exc()
            print "No Lookups Found!"
            pass

    def WriteImage(self,image):

        cursor = self.db.cursor()

        if len(image) == 0:
            return
        try:
            qry = "INSERT INTO " + self.table
            if self.lookups == True:
                qry += "_data"
            
            qry += " ( " + self.lookup+ "," + self.value+ "," + self.stamp + ") VALUES "
            first = True
            for key in image:
                if first == True:
                    first = False
                else:
                    qry += ","
                if self.lookups == True:
                    vl = self.lutable[key]
                    #print (str(self.lutable))
                    qry += "(" + str(vl) + "," + repr(image[key].encode('ascii','ignore')) + ",GETDATE())"
                else:    
                    qry += "(" + repr(key) + "," + repr(image[key].encode('ascii','ignore')) + ",GETDATE())"

            #print qry
            cursor.execute(qry)
            self.db.commit()
        except:
            traceback.print_exc()
            self.Connect()