import sys
import time
import psycopg2
import traceback

class dbwriter:
    def __init__(self,addr):
        self.db = False
        self.address = addr

    def Connect(self):
        try:
            print "Establishing PostgreSQL Connection..."
            bits = self.address.split(':')

            self.table = bits[5]
            self.lookup = bits[6]
            self.stamp = bits[7]
            self.value = bits[8]
            self.db = psycopg.connect(host=bits[0] + ":" + bits[1],user=bits[3],password=bits[4],database=bits[2],login_timeout=10)#MySQLdb.connect(bits[0],bits[3],bits[4],bits[2],port=int(bits[1]))
            print "Connection Successful!"
            return True
        except:
            traceback.print_exc()
            return False

    def Prepare(self,channels):
        self.lookups = False
        #print "Checking For Lookup Table..."
        #Check to see if a lookup table exists...
        try:
            cursor = self.db.cursor()

            cursor.execute("SELECT name,id FROM " + self.table + "_lookup")
            results = cursor.fetchall()
            self.lutable = {}
            for r in results:
                self.lutable[r[0]] = r[1]

            #OK - we've loaded all of the existing lookups!

            #Are any missing?
            syncer = ""
            
            for v in channels:
                if v.field not in self.lutable:
                    if (syncer != ""):
                        syncer += ","
                    syncer += "('" + self.db.escape_string(v.field) + "')"

            if syncer != "":

                qry = "INSERT INTO " + self.table + "_lookup (name) VALUES " + syncer
                print qry
                self.db.query(qry)
                #print "Updating Lookup Table With New Options"

                cursor = self.db.cursor()
                cursor.execute("SELECT name,id FROM " + self.table + "_lookup")
                results = cursor.fetchall()
                self.lutable = {}
                for r in results:
                    self.lutable[r[0]] = r[1]

            self.lookups = True
            print "Lookup Found!"

            #print str(self.lutable)
        except:
            traceback.print_exc()
            print "No Lookups Found!"
            pass

    def WriteImage(self,image):
        
        if len(image) == 0:
            return
        try:
            qry = "INSERT INTO " + self.table +" (" + self.lookup + ", " + self.value+ "," + self.stamp + ") VALUES "
            first = True
            for key in image:
                if first == True:
                    first = False
                else:
                    qry += ","
                if self.lookups == True:
                    qry += "(" + str(self.lutable[key]) + ",'" + self.db.escape_string(image[key]) + "',NOW())"
                else:    
                    qry += "('" + self.db.escape_string(key) + "','" + self.db.escape_string(image[key]) + "',NOW())"

            #print qry
            self.db.query(qry)
            self.db.commit()
        except:
            traceback.print_exc()
            self.Connect()